/* ------------------------------------------------------------------------ --
--                                                                          --
--                        PLT-Editor (edplt)                                --
--                                                                          --
--  Copyright @ 2009-     J. Holzmann                                       --
--                        webmaster@woodym.de                               --
--                                                                          --
-- ------------------------------------------------------------------------ --
--                                                                          --
--                                                                          --
--  This software is given without any warranty. It can be distributed      --
--  free of charge as long as this header remains, unchanged.               --
--                                                                          --
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "About.h"
#include "serial_send.h"
#include "xhpgl.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------

__fastcall TMainForm::TMainForm(TComponent *Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CreateMDIChild(String Name)
{
	TMDIChild *Child;

	//--- create a new MDI child window ----
	Child = new TMDIChild(Application);
	Child->Caption = Name;
	if (FileExists (Name))
	{
		Child->load_plt(Child->PaintBox1,Name);
	}
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::FileOpen1Execute(TObject *Sender)
{
	if (OpenDialog->Execute())
		CreateMDIChild(OpenDialog->FileName);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::HelpAbout1Execute(TObject *Sender)
{
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileExit1Execute(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FileSave1Execute(TObject *Sender)
{
	if(ActiveMDIChild)
	{
		ActiveMDIChild->Action->Execute();
//		dynamic_cast< TMDIChild* >( ActiveMDIChild )->to_real(0,0);
//			ActiveMDIChild->Caption="aaa";
//			ActiveMDIChild->Action->
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::RS232Execute(TObject *Sender)
{
//		dynamic_cast< TMDIChild* >( ActiveMDIChild )->to_real(0,0);
	SendBox->MDIChild=ActiveMDIChild;
	SendBox->ShowModal();
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::XHPGLExecute(TObject *Sender)
{
	int i;

	XHPGLBox->MDIChild=ActiveMDIChild;
	XHPGLBox->ListBox1->Items->Clear();
	for(i=0;i<MDIChildCount;i++)
	{
		XHPGLBox->ListBox1->Items->AddObject(MDIChildren[i]->Caption.Delete(1, MDIChildren[i]->Caption.LastDelimiter("\\")),MDIChildren[i]);
		if(MDIChildren[i]==ActiveMDIChild)
		{
			XHPGLBox->ListBox1->Selected[i]=true;
        }
	}
	XHPGLBox->ShowModal();
}
//---------------------------------------------------------------------------


